# Grab Drop Plugin

This unofficial TaleSpire plugin is for adding allowing minis to grab and drop each other.
While a mini is grabbed it will move along with the mini that grabbed it. When a mini is
dropped it will no longer move along with the mini that grabbed it. Typically this is used
with mini and prop mini to have minis pick up (and drop) props.

Special thanks to AlbrechtWM for implementinmg significant bug fixes, multi grab mode and
optional integration (if plugin is present) with States Plugin.
 
## Change Log

1.4.5: Fixed compatibility with latest Radial UI plugin version. 
1.4.0: Bug Fix: Effects are not deleted properly when parent is deleted.
1.3.0: Displays leader (grabbing mini) using States Plugin if plugin is installed.
1.1.0: Multi grab mode allow mini to grab more than one prop/mini.
1.1.0: Correct drop to also work based on the selected mode.
1.1.0: Correct issue with a grabbing parent being removed.
1.0.0: Initial release

## Install

Install using R2ModMan.

## Usage

The configuration for the plugin has two mode "Select Prop" and "Select Mini". You can set
the desired mode using R2ModMan configuration editor for this plugin.

To use the plugin you need to select the prop mini and the grabbing mini. The mode determines
which of those two items is actually selected and on which the radial menu is opened.

### Select Prop Mode

In this mode, the prop mini is selected and then the right mouse button is used on the grabbing
mini to select the Grab option. This will cause the grabbing mini to move the prop mini along
whenever it moves. To drop the prop, the prop mini is selected and then the right mouse button
is used on the grabbing mini and the Drop option is selected.

### Select Mini Mode

In this mode, the grabbing mini is selected and then the right mouse button is used on the prop
mini to select the Grab option. This will cause the grabbing mini to move the prop mini along
whenever it moves. To drop the prop, the grabbing mini is selected and then right mouse button
is used on the desired prop and the Drop option is selected.

### Grabbed Item Location

A prop mini can be grabbed at any distance. Once grabbed it will keep the same position offset
to the grabbing mini as when it was grabbed. This means that this effect can be used not only
to represent physical grabs but also things like telekinetic powers (i.e. activate the grab
when the item is not adjacent).

While an item is grabbed it can still be moved independently thus adjusting the offset between
itself and the grabbing mini. This can be used to adjust the position of the grabbed item with
respect to the grabber without having to drop and re-grab the item. To do this just select the
prop mini as usual and use the usual methods to move it.

## Known Limitations

1. Current grabbing is a simple parenting so it is more of a "drag" than actual "pick up".
   Future version may implement a more specific grab (such as right and left hand) for minis
   which have a bone structure.

2. Odd effect may occur when moving a grabbed object near walls. It has not been fully tested
   what happens when a item is grabbed and then dragged in such a way that it would end up in
   a wall.   
